import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class GenericRobot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GenericRobot extends Actor
{
    protected RandomMaze world;
    protected int facing = 2;

    public GenericRobot()
    {
        world = RandomMaze.instance;
        setImage( world.robot_images[facing] );
    }


    /**
     * Act - do whatever the GenericRobot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    

    public void moveForward()
    {
        if (obstacleInFront()) return;

        int x = getX();
        int y = getY();
        int dx = 0;
        int dy = 0;
        switch (facing)
        {
            case 0: dy--; break;
            case 1: dx++; break;
            case 2: dy++; break;
            case 3: dx--; break;
        }

        if (!footprintsAt()) world.addObject( new Footprint(), x, y );

        world.removeObject( this );
        world.addObject( this, x+dx, y+dy );
    }

    public void turnRight()
    {
        facing = (facing + 1) % 4;
        setImage( world.robot_images[facing] );
    }

    public void turnLeft()
    {
        facing = (facing + 3) % 4;
        setImage( world.robot_images[facing] );
    }

    public boolean obstacleInFront()
    {
        int x = getX();
        int y = getY();
        int dx=0, dy=0;
        switch (facing)
        {
            case 0: dy--; break;
            case 1: dx++; break;
            case 2: dy++; break;
            case 3: dx--; break;
        }

        List objects = getObjectsAtOffset(dx,dy,null);
        for (Object obj : objects)
        {
          if (obj instanceof GenericRobot) return true;
          if (obj instanceof Wall) return true;
        }
        return false;
    }

    public boolean footprintsInFront()
    {
        int x = getX();
        int y = getY();
        int dx=0, dy=0;
        switch (facing)
        {
            case 0: dy--; break;
            case 1: dx++; break;
            case 2: dy++; break;
            case 3: dx--; break;
        }

        return getObjectsAtOffset(dx,dy,Footprint.class).size() > 0;
    }

    public boolean footprintsAt()
    {
      return getObjectsAtOffset(0,0,Footprint.class).size() > 0;
    }
}
